#define red_PWM_enable() (TCCR0A |= (1 << COM0B1))
#define red_PWM_disable()(TCCR0A &= ~(1 << COM0B1))
#define red_off() (PORTD &= ~(1 << PD5))
#define green_PWM_enable() (TCCR2A |= (1 << COM2B1))
#define green_PWM_disable()(TCCR2A &= ~(1 << COM2B1))
#define green_off() (PORTD &= ~(1 << PD3))
#define blue_PWM_enable() (TCCR0A |= (1 << COM0A1))
#define blue_PWM_disable()(TCCR0A &= ~(1 << COM0A1))
#define blue_off() (PORTD &= ~(1 << PD6))
#define led8_on() (PORTB &= ~(1 << PB0))
#define led8_off() (PORTB |= (1 << PB0)) 
#define led9_on() (PORTB &= ~(1 << PB1))
#define led9_off() (PORTB |= (1 << PB1)) 
#define led10_on() (PORTB &= ~(1 << PB2))
#define led10_off() (PORTB |= (1 << PB2)) 
#define led11_on() (PORTB &= ~(1 << PB3))
#define led11_off() (PORTB |= (1 << PB3)) 

volatile uint8_t *red_intensity = &OCR0B;
volatile uint8_t *blue_intensity = &OCR0A;
volatile uint8_t *green_intensity = &OCR2B;
volatile uint8_t *timer0 = &TCNT0;

void setup() {
  DDRB = B00001111;
  DDRD = B01101000;
  PORTB = B00001111;

  noInterrupts(); // disable interrupts
  // make sure that Timer2 work in same mode as Timer0
  TCCR2A |= (1 << WGM21); 
  interrupts(); // enable interrupts
}

void loop() {
  delay(200);
  for (  int intensity = 0; intensity <=255; intensity++){
    D8_D11(intensity);
  }
  for ( int intensity = 255; intensity >=0; intensity--){
    D8_D11(intensity);
  }
}

void D8_D11(int intensity) {
  red_PWM_enable();
  *red_intensity = intensity;
  while ( *timer0 == 255 ) {}
  led8_on();
  while ( *timer0 < 255 ) {}
  led8_off();
  red_PWM_disable();
  red_off();

  green_PWM_enable();
  *green_intensity = intensity;
  while ( *timer0 == 255){}
  led9_on();
  while ( *timer0 < 255){}
  led9_off();
  green_PWM_disable();
  green_off();

  blue_PWM_enable();
  *blue_intensity = intensity;
  while ( *timer0 == 255){}
  led10_on();
  while ( *timer0 < 255){}
  led10_off();
  blue_PWM_disable();
  blue_off();

  red_PWM_enable();
  *red_intensity = intensity;
  green_PWM_enable();
  *green_intensity = intensity;
  blue_PWM_enable();
  *blue_intensity = intensity;
  while ( *timer0 == 255){}
  led11_on();
  while ( *timer0 < 255){}
  led11_off();
  red_PWM_disable();
  red_off();
  green_PWM_disable();
  green_off();
  blue_PWM_disable();
  blue_off();
}
